struct fitness perf (struct position x, struct problem pb, int option, 
				int aroundNb, int SwarmSize, int normalise) 
{				// Evaluate the fitness value for the particle of rank s 

	struct position around[DMax+1];
	double c;
	int d;
	double dist,dMax;
	double DD;
	int deb;
	int dim;
	double dTheta;
	double dx1,dx2;	
	int  i,j,k;
	int n,n1;
	double f=0;
	struct fitness ff={0};
	double f1,f2;
	int grid;
	double p;
	double s11, s12, s21, s22;
	double sum1,sum2;
	struct SS SSaround;
	double t0, tt, t1;
	double x1,x2,x3,x4;
	double xd;
	struct position xs;
	double xy[8][2];
	double y,y1,y2; 
	double z,z2;
	double zz[8][8];

#include "cec2005data.c"

	// Data for center-bias test function (code 6)
	double radius=10; // 
	int shift=1;  // Set to zero in order to have the center on {0, ...,0}, to 1 else
	double center[30]=
	{
		80, -20,  1.9231600e+001, -2.5231000e+000,  7.0433800e+001, 
		4.7177400e+001, -7.8358000e+000, -8.6669300e+001,  5.7853200e+001, -9.9533000e+000,
		2.0777800e+001,  5.2548600e+001,  7.5926300e+001,  4.2877300e+001, -5.8272000e+001,
		-1.6972800e+001,  7.8384500e+001,  7.5042700e+001, -1.6151300e+001,  7.0856900e+001,
		-7.9579500e+001, -2.6483700e+001,  5.6369900e+001, -8.8224900e+001, -6.4999600e+001,
		-5.3502200e+001, -5.4230000e+001,  1.8682600e+001, -4.1006100e+001, -5.4213400e+001
	};
	struct position summit;

	nEval=nEval+1; // Number of fitness evaluations (global variable)

	//----------------------------------------------------
	ff.size=1; // Default value (no constraint)

	switch(option)
	{
		default: break;
		/*
		 case 4: // Simplified form, when using just two points
		 z=0.5*(pb.SS.max[d]-pb.SS.min[d])/(SwarmSize+1);
		 for (d=0;d<x.size;d++)
		 {


		 }
		 */
		case 4: // Do  not compute the fitness of the position x, but 
			// generate aroundNb points "around" x ...
			SSaround.D=x.size;
		for (d=0;d<x.size;d++) // Define the local domain
		{
			z=0.5*(pb.SS.max[d]-pb.SS.min[d])/(SwarmSize+1); // ???
			//z=(1./3)*(pb.SS.max[d]-pb.SS.min[d])/(SwarmSize+1); // ???
			SSaround.max[d]= x.x[d]+z; 
			if(SSaround.max[d]>pb.SS.max[d]) SSaround.max[d]=pb.SS.max[d];
			SSaround.min[d]= x.x[d]-z; 
			if(SSaround.min[d]<pb.SS.min[d]) SSaround.min[d]=pb.SS.min[d];

			SSaround.q.size=x.size;
			SSaround.q.q[d]=pb.SS.q.q[d];
			SSaround.maxS[d]=SSaround.max[d];
			SSaround.minS[d]=SSaround.min[d];
		}
		/*
		 // (define aroundNb points in the local domain)
		 for (i = 0; i < aroundNb; i++)   // Random
		 {
			 around[i].size=x.size;
			 for(d=0;d<x.size;d++)
				 around[i].x[d]=alea(SSaround.min[d],SSaround.max[d]);
		 }
		 */

		deb=alea_integer(0,aroundNb-1); // Improved Hammersley
		for (i = 0; i < aroundNb; i++)   
		{
			around[i]=hammersley(SSaround,aroundNb, deb,i);
		}

		// ... and compute the mean of their fitnesses
		ff=perf(x,pb,0,0,0,normalise);
		f=ff.f[0];
		for(i=0;i<aroundNb;i++)
		{	 
			ff=perf(around[i],pb,0,0,0,normalise);
			f=f+ff.f[0];
		}
			
		ff.f[0]=fabs(f/(aroundNb+1)-pb.objective);
		return ff;
	}

	xs.size=x.size;
	ff.size=1; // Default value (no constraint)

	if(normalise>0) // The search space is normalised as [0,1]^D
									// We have to consider the real position
	{
		for (d = 0; d < xs.size; d++) 
		{
			xs.x[d]=pb.SS.minR[d]+ x.x[d]*(pb.SS.maxR[d]-pb.SS.minR[d]);
		}
	}
	else
	{
		xs=x;
	}

	switch (pb.function)
	{
		default:
		ERROR("Wrong code function");
		break;
#include "cec2005.c" // CEC 2005 benchmark

		case 0:		// Parabola (Sphere)
			f=0.;
		for (d = 0; d < xs.size; d++) 
		{
			xd = xs.x[d];    
			//xd = xs.x[d]-50; // Shifted

			f = f + xd * xd;    
		}	
		//printf("\n2442  xs.size %i f %f x0 %f",xs.size,f,xs.x[0]);
		break;

		case 1:		// Griewank
			f = 0; 
		p = 1;

		for (d = 0; d < xs.size; d++)
		{      
			xd = xs.x[d];
			//xd=xd-150;
			f = f + xd * xd;	      
			p = p * cos (xd / sqrt ((double) (d + 1)));	    
		} 
		f = f / 4000 - p + 1;	  
		break;

		case 2:		// Rosenbrock
			f = 0;  
		t0 = xs.x[0]  + 1;	// Solution on (0,...0) 
		for (d = 1; d < xs.size; d++)
		{     

			t1 = xs.x[d]  + 1;	    
			tt = 1 - t0;	      
			f += tt * tt;      
			tt = t1 - t0 * t0;      
			f += 100 * tt * tt;	      
			t0 = t1;    
		}  
		break;

		case 3:		// Rastrigin
			f=0;
		k = 10;  

		for (d = 0; d < xs.size; d++)    
		{     
			xd = xs.x[d];	      
			f =f+ xd * xd - k * cos (2 * pi * xd);	    
		}	  
		f =f+ xs.size * k;  
		break;

		case 4:		// 2D Tripod function
			// Note that there is a big discontinuity right on the solution
			// point. 	
			x1 = xs.x[0] ; 
		x2 = xs.x[1];  
		s11 = (1.0 - sign (x1)) / 2;
		s12 = (1.0 + sign (x1)) / 2; 
		s21 = (1.0 - sign (x2)) / 2;
		s22 = (1.0 + sign (x2)) / 2;

		//f = s21 * (fabs (x1) - x2); // Solution on (0,0)
		f = s21 * (fabs (x1) +fabs(x2+50)); // Solution on (0,-50)  
		f = f + s22 * (s11 * (1 + fabs (x1 + 50) + fabs (x2 - 50)) 
		               + s12 * (2 +fabs (x1 - 50) + fabs (x2 - 50)));	  
		break;

		case 5:  // Ackley
			sum1=0;
		sum2=0;
		DD=x.size;
		pi=acos(-1);
		for (d=0;d<x.size;d++)
		{
			xd=xs.x[d];
			sum1=sum1+xd*xd;
			sum2=sum2+cos(2*pi*xd);
		}
		f=-20*exp(-0.2*sqrt(  sum1/DD  ))-exp(sum2/DD)+20+exp(1);	
		break;

		case 6:  // Center-bias test function
			// on [-100,100]^2
			for(d=0;d<x.size;d++) summit.x[d]=shift*center[d];

		z=distanceL(x,summit,2);
		if(z>radius) f=radius; else f=z;		
		break;

		case 7: // Pressure vessel (penalty method)
		case 1007: // confinement method
			// Ref New Optim. Tech. in Eng. p 638
			// D = 4          
		x1=xs.x[0]; // [1.1,12.5] granularity 0.0625
		x2=xs.x[1];// [0.6,12.5] granularity 0.0625
		x3=xs.x[2]; // [0,240]
		x4=xs.x[3];// [0,240]

		f=0.6224*x1*x3*x4 + 1.7781*x2*x3*x3 + 3.1661*x1*x1*x4 +
			19.84*x1*x1*x3;

		ff=constraint(xs,pb.function,pb.epsConstr);
		
		if(pb.constraint==0)// Constraints, by penalty method
		{
			if (ff.f[1]>0) {c= 1+pow(10,10)*ff.f[1];  f=f*c*c; }
			if (ff.f[2]>0) {c=1+ff.f[2]; f=f*c*c;  }
			if (ff.f[3]>0) {c=1+ff.f[3]; f=f*c*c;  }
		}
		break;

		case 8: // Coil compression spring  (penalty method)
			// Ref New Optim. Tech. in Eng. p 644
		case 1008: // confinement method

		x1=xs.x[0]; // {1,2, ... 70}
		x2= xs.x[1];//[0.6, 3]
		x3= xs.x[2];// relaxed form [0.207,0.5]  dx=0.001
		// In the original problem, it is a list of
		// acceptable values
		// {0.207,0.225,0.244,0.263,0.283,0.307,0.331,0.362,0.394,0.4375,0.5}

		f=pi*pi*x2*x3*x3*(x1+2)*0.25;
		// Constraints
		ff=constraint(xs,pb.function,pb.epsConstr);
		if(pb.constraint==0)
		{
			if (ff.f[1]>0) {c=1+ff.f[1]; f=f*c*c*c;}
			if (ff.f[2]>0) {c=1+ff.f[1]; f=f*c*c*c;}
			if (ff.f[3]>0) {c=1+ff.f[3]; f=f*c*c*c;}
			if (ff.f[4]>0) {c=1+pow(10,10)*ff.f[4]; f=f*c*c*c;}
			if (ff.f[5]>0) {c=1+pow(10,10)*ff.f[5]; f=f*c*c*c;}
		}
		break;

		case 9: // Gear train
			x1=xs.x[0]; // {12,13, ... 60}
		x2= xs.x[1];// {12,13, ... 60}
		x3= xs.x[2];// {12,13, ... 60}
		x4= xs.x[3];// {12,13, ... 60}

		f=1./6.931 - x1*x2/(x3*x4);
		f=f*f;
		break;

// case 10
#include "cellular_phone.c"
printf("\n perf 283 f %f",f);

		case 11: // PAPR/OFDM
			//printf("\n");
			for(i=0;i<aSize;i++)
		{
			Y[i][0]=0; Y[i][1]=0;
			for(j=0;j<pb.SS.D;j=j+2)
			{
				Y[i][0]=Y[i][0]+xs.x[j]*a[j][i]-xs.x[j+1]*a[j+1][i]; // Real part
				Y[i][1]= Y[i][1]+xs.x[j]*a[j+1][i]+xs.x[j+1]*a[j][i]; // Imaginary part
			}
			//printf("%f ",Y[i]);
		}
		//printf("\n"); for(i=0;i<D;i++) printf("%i ",x.bit.b[i]);
		// max(Y[i]^2), equivalent to max(abs(Y[i]))
		f= Y[0][0]*Y[0][0]+Y[0][1]*Y[0][1];
		for(i=1;i<aSize;i++)
		{
			z=Y[i][0]*Y[i][0]+Y[i][1]*Y[i][1];
			if(z>f) f=z;  
		}

		// Penalties for constraints
		for(d=0;d<pb.SS.D;d=d+2) // For each complex solution (two real ones) ...
		{
			z=fabs(xs.x[d]) + fabs(xs.x[d+1]); 
			if(z>1+zero || z<1-zero) // ... the module must be equal to 1
			{
				f=f+paprPenalt;
			} 

		}
		//printf("\nf %f",f);
		break;

		case 12: // Schwefel
		f=418.98288727243369*pb.SS.D;
		for(d=0;d<pb.SS.D;d++) 
		{
			xd=xs.x[d];
			f=f-xd*sin(sqrt(fabs(xd)));
		}
		break;
		case 13: // Cutting problem
			sum1=0;
		f=0;
		for(d=0;d<pb.SS.D;d++) // Waste
		{
			sum1=sum1+xs.x[d];
			if(sum1<toCut && d<pb.SS.D-1) continue;
			if(sum1<toCut && d==pb.SS.D-1) 
			{
				f=f+toCut-sum1;
				continue;
			}
			f=f+toCut-sum1+xs.x[d];
			sum1=xs.x[d];
		}

		//Constraints
		for(i=0;i<pb.SS.valueNb;i++) // For each value ...
		{
			n=0;
			for(d=0;d<pb.SS.D;d++) // ... count how many times it appears
			{
				if(xs.x[d]>=valueList[i]-zero && xs.x[d]<=valueList[i]+zero)
					n=n+1;
				//printf("\n 2732  %f %f %f",valueList[i]-zero,xs.x[d], valueList[i]+zero); 
			}
			if(n!=pieceNb[i]) // If not exactly the right number of times => penalty
			{
				f= f+toCut; // f+100000
				//printf("\n 2716, %i, %i, should be %i",i,n,pieceNb[i]);
			}
		}
		//printf("\n2740 f %f",f);	 
		break;

		case 14: // Polygon. longest perimeter
			// Cartesian coordinates
			xy[0][0]=0; xy[0][1]=0;
		xy[1][0]=xs.x[0]; xy[1][1]=0;
		i=2;
		for(d=1;d<pb.SS.D;d=d+2)
		{
			xy[i][0]=xs.x[d+1]*cos(xs.x[d]); // rho*cos(theta)
			xy[i][1]=xs.x[d+1]*sin(xs.x[d]); // rho*sin(theta)
			i=i+1;
		}

		// Distances
		n=i;
		z2=0; // Distance max
		y=0; // Sum of the distances
		for(i=1;i<n;i++)
		{
			for(j=0;j<i;j++)
			{
				zz[i][j]=sqrt(pow(xy[i][0]-xy[j][0],2)+pow(xy[i][1]-xy[j][1],2));
				y=y+zz[i][j];
				if(zz[i][j]>z2) z2=zz[i][j];
			}
		}

		// Perimeter 
		//	f=zz[n-1][0];
		//	for(i=1;i<n;i++) f=f+zz[i][i-1];

		// To minimise
		//f=2+4*sin(pi/12)-f;
		f=pi-f;

		// Max sum of the distances y
		f=n*(n-1)-y ; //to minimise

		// Constraints -----
		p=(n-2)*pi; // penalty
		//dTheta=(n-2)*pi/(2*n);
		dTheta=zero;
		// Diameter = 1
		if(z2>1+zero) f=f + p;
		if(z2<1-zero) f=f+p;

		// Convex
		for(d=1;d<pb.SS.D-2;d=d+2) // Increasing theta
		{
			//if(xs.x[d]>xs.x[d+2]) f=f+p;
			if(xs.x[d+2]<xs.x[d]+dTheta) f=f+p;
		}

		// Angle max
		if(xs.x[pb.SS.D-2]>pi) f=f+p;

		// Sides
		for(d=2;d<pb.SS.D-2;d=d+2)
		{
			if(xs.x[d]<xs.x[d-2] && xs.x[d]<xs.x[d+2] ) f=f+p;
		}

		//if(xs.x[0]<0.2) f=f+p;
		/*
		 for(d=2;d<pb.SS.D;d=d+2) // 
		 {
			 if(xs.x[d]<xs.x[0]) f=f+p;
		 }
		 */
		break;

		case 15: // Constrained g13, Penalty method
		case 1015: // 			Confinement method
			// D = 5      
		 // x1, x2 in [-2.3, 2.3] 
		// x3, x4, x5 [-3.2, 3.2]

		f=exp(xs.x[0]*xs.x[1]*xs.x[2]*xs.x[3]*xs.x[4]);
		ff=constraint(xs,pb.function,pb.epsConstr);

		if(pb.constraint==0) // Penalty method
		{
			if(ff.f[1]>0) f=f+ff.f[1]; 
			if(ff.f[2]>0) f=f+ff.f[2]; 
 			if(ff.f[3]>0) f=f+ff.f[3]; 
		}
		
		break;
		
		case 16: // G3 (constrained) 
							// min =0 on (1/sqrt(D), ...)
				f=1;
			sum1=0;
			for (d=0;d<x.size;d++)
		{
			xd = xs.x[d];
			f=f*xd;
			sum1=sum1+xd*xd;
		}
			f=fabs(1-pow(x.size,x.size/2)*f) + x.size*fabs(sum1-1);
			break;

		case 99: // Test

			// 1D Test "deceptive" on [0 1]
			xd=xs.x[0];
		if (xd<0.6) f=xd;
		else f=0.6-(0.5/0.4)*(xd-0.6);
		break;

		// 1D test  [-50, 50]
		xd=xs.x[0];
		f=xd*(xd+1)*cos(xd);
		break;

		// KrishnaKumar
		f = 0;
		for ( d = 0; d < xs.size - 1; d++ )
		{
			f = f + sin( xs.x[d] + xs.x[d + 1] ) + sin( 2 * xs.x[d] * xs.x[d + 1] / 3 );
		}
		break;

		xd=xs.x[0];
		//if (xd<9) f=10-xd; else f=10*xd-90;	
		if (xd<=1) f=10*xd; else f=11-xd;	
		break;

		case 1000: //1-D  Landscape on a file
			// Find the nearest x
			xd=xs.x[0];
		z=fabs(xd-funct.x[0]);
		f=funct.fx[0];
		for(d=1;d<funct.N;d++)
		{
			z2=fabs(xd-funct.x[d]);
			if(z2<z)
			{
				z=z2;
				f=funct.fx[d];
			}
		}
		break;

		case -1: // Repartition of points. L_infinity + L2
			dim=pb.SS.D/pb.nb;

		// Distance to the centre (L_infinity)
		f1=0;
		for(n=0;n<pb.nb;n++)
		{
			for(d=0;d<dim;d++)
			{
				z=0.5*(pb.SS.min[d]+pb.SS.max[d]); // Centre
				z2=fabs(xs.x[d+n*dim]-z); // distance to the centre

				z=0.5*(pb.SS.max[d]-pb.SS.min[d])-z2;
				if(z>zero) f1=f1+1/z
					- 2/(pb.SS.max[d]-pb.SS.min[d]);
				else f1=infinity;
			}
		}

		// Distance to the other points (L2 = Euclidean)
		f2=0;
		for(n=0;n<pb.nb-1;n++)
		{
			for(n1=n+1;n1<pb.nb;n1++)
			{	
				z2=0;
				for(d=0;d<dim;d++)
				{
					z=xs.x[d+n*dim]-xs.x[d+n1*dim];
					z2=z2+z*z;
				}
				if(z2>zero) f2=f2+1./sqrt(z2); else f2=infinity;
			}
		}

		f=f1 + f2*dim*2./(pb.nb-1);
		break;

		case -2: // // Repartition of points  - L2 + L2
			dim=pb.SS.D/pb.nb;

		// Distance to the centre (L_2)
		f1=0;
		dMax=0;
		for(n=0;n<pb.nb;n++)
		{
			z2=0;
			for(d=0;d<dim;d++)
			{
				z=xs.x[d+n*dim]-0.5*(pb.SS.min[d]+pb.SS.max[d]); // distance to the centre
				z2=z2+z*z;
				dist=0.5*(pb.SS.max[d]-pb.SS.min[d]);
				dMax=dMax+dist*dist;
			}
			z2=sqrt(z2);
			dMax=sqrt(dMax);
			z=dMax-z2; // dMax - distance_to_centre

			if(z>zero)
			{
				f1=f1+1/z -1/dMax;							
			}
			else
				f1=infinity;
		}

		// Distance to the other points (L_2)
		f2=0;
		for(n=0;n<pb.nb-1;n++)
		{
			for(n1=n+1;n1<pb.nb;n1++)
			{	
				z2=0;
				for(d=0;d<dim;d++)
				{
					z=xs.x[d+n*dim]-xs.x[d+n1*dim];
					z2=z2+z*z;
				}
				if(z2>zero) f2=f2+1./sqrt(z2); else f2=infinity;
			}
		}

		f=f1 + f2*2./(pb.nb-1);
		break;
	}

	ff.f[0]=fabs(f-pb.objective);
	return ff;

}
//================================================
double errorFC(struct fitness f)
{
	// Error, including the constraints
	double error;
	int n;
	error=f.f[0];

	if(f.size==1) return error;

	for(n=1;n<f.size;n++) 
			if(f.f[n]>0) error=error+f.f[n];

	return error;

}