// =============================================================================
double max(double a,double b) { if (a<b) return b; return a;}
double min(double a,double b) { if (a<b) return a; return b;}
// =============================================================================
int sign (double x) 
{    // Be careful: not the classical one 
	if (x <= 0)	return -1;    
	return 1;   
}


/* 
 // ===========================================================
 double normL (struct velocity v,double L) 
 {   // L-norm of a vector
	 int d;     
	 double n;

	 n = 0;

	 for (d = 0; d < v.size; d++)
		 n = n + pow(fabs(v.v[d]),L);

	 n = pow (n, 1/L);     
	 return n;  
 }
 */ 

// ===========================================================
double distanceL (struct position x1, struct position x2,double L) 
{  // Distance between two positions
	// L = 2 => Euclidean	
	int d;     
	double n;

	n = 0;

	for (d = 0; d < x1.size; d++)
		n = n + pow (fabs(x1.x[d] - x2.x[d]), L);

	n = pow (n, 1/L);
	return n;    
}