
	// Compute all the distances to the memorised positions M[.]
	for(m=0;m<krigin.MSize;m++)
	{
		krigin.M[m].d=distanceL(krigin.M[m],SW.P[s],2);
	}		
	// Sort the memorised positions by distance to the best best
	// Note: this is necessary only if param.aroundNb < MMax
	qsort(krigin.M,krigin.MSize,sizeof(krigin.M[0]),compareDist);

	// Keep the aroundNb best (define the list of points to interpolate) 
	// Find the best model for the variogram 

	// 1. Find the min and the max for each dimension
	for(d=0;d<dim;d++)
	{
		krigin.xMin[d]=krigin.M[0].x[0];
		krigin.xMax[d]=krigin.xMin[d];

		for(m=1;m<param.aroundNb;m++)
		{
			if(krigin.M[m].x[d]<krigin.xMin[d]) krigin.xMin[d]=krigin.M[m].x[d];
			if(krigin.M[m].x[d]>krigin.xMax[d]) krigin.xMax[d]=krigin.M[m].x[d];
		}	
	}

	// 2. Compute the variogram and its best model
	krigin.Gamma=variogram(krigin.M,krigin.MSize,krigin.xMin,krigin.xMax);

	//printf("\n");	matrixDisplay(Gamma.G);	
	// 3. Optimise the modelled/surrogate function
	xv.x=modelFunctOptim(krigin.M,krigin.Gamma,krigin.xMin,krigin.xMax);
	xv.x.forced=1; 
